searchData={"items":[{"type":"module","title":"ExOqs","doc":"Documentation for `ExOqs`.","ref":"ExOqs.html"},{"type":"function","title":"ExOqs.hello/0","doc":"Hello world.","ref":"ExOqs.html#hello/0"},{"type":"function","title":"Examples - ExOqs.hello/0","doc":"iex> ExOqs.hello()\n    :world","ref":"ExOqs.html#hello/0-examples"},{"type":"module","title":"ExOqs.Liboqs","doc":"Main interfacing module for liboqs NIF","ref":"ExOqs.Liboqs.html"},{"type":"function","title":"ExOqs.Liboqs.decaps/3","doc":"Decapsulate KEM with recipient private key. Same shared key shall be obtained from\nencaps process above","ref":"ExOqs.Liboqs.html#decaps/3"},{"type":"function","title":"Example: - ExOqs.Liboqs.decaps/3","doc":"iex> {:ok, shared_key} = ExOqs.Liboqs.decaps(:Kyber768, private)\n        {:ok,\n         <<80, 216, 149, 77, 19, 146, 165, 120, 185, 199, 75, 103, 2, 181, 95, 249, 76,\n           221, 12, 206, 58, 155, 222, 182, 129, 54, 27, 80, 189, 199, 22, 66>>}","ref":"ExOqs.Liboqs.html#decaps/3-example"},{"type":"function","title":"ExOqs.Liboqs.encaps/2","doc":"Encapsulate KEM with recipient public key","ref":"ExOqs.Liboqs.html#encaps/2"},{"type":"function","title":"Example: - ExOqs.Liboqs.encaps/2","doc":"iex> {:ok, {shared_cipher, shared_key}} = ExOqs.Liboqs.encaps(:Kyber768, public)\n  {:ok,\n    {<<78, 103, 59, 120, 122, 155, 20, 23, 121, 246, 195, 175, 240, 176, 58, 34,\n       67, 236, 191, 252, 172, 117, 7, 92, 192, 66, 61, 142, 87, 61, 62, 79, 174,\n       218, 139, 250, 154, 81, 72, 60, 249, 121, 174, 7, 125, 176, 74, ...>>,\n     <<80, 216, 149, 77, 19, 146, 165, 120, 185, 199, 75, 103, 2, 181, 95, 249, 76,\n       221, 12, 206, 58, 155, 222, 182, 129, 54, 27, 80, 189, 199, 22, 66>>}}","ref":"ExOqs.Liboqs.html#encaps/2-example"},{"type":"function","title":"ExOqs.Liboqs.generate_kem_keypair/1","doc":"Generate KEM keypoir of specific algorithm","ref":"ExOqs.Liboqs.html#generate_kem_keypair/1"},{"type":"function","title":"Example: - ExOqs.Liboqs.generate_kem_keypair/1","doc":"iex> {:ok, {public, private}} = ExOqs.Liboqs.generate_kem_keypair(:Kyber768)\n  {:ok,\n  {<<197, 163, 78, 148, 197, 11, 136, 34, 100, 8, 168, 107, 125, 224, 199, 160,\n    148, 164, 108, 20, 10, 242, 101, 161, 245, 113, 160, 215, 233, 1, 133, 214,\n    96, 120, 147, 126, 198, 12, 131, 79, 1, 37, 65, 3, 82, 214, 2, ...>>,\n  <<107, 179, 144, 98, 131, 72, 6, 51, 117, 115, 50, 136, 178, 49, 5, 44, 203,\n    205, 70, 107, 143, 56, 89, 185, 104, 240, 169, 79, 149, 131, 34, 163, 126,\n    241, 249, 61, 88, 211, 69, 101, 135, 148, 99, 178, 167, 144, ...>>}}","ref":"ExOqs.Liboqs.html#generate_kem_keypair/1-example"},{"type":"function","title":"ExOqs.Liboqs.generate_sign_keypair/1","doc":"Generates keypair for given SIG algorithm","ref":"ExOqs.Liboqs.html#generate_sign_keypair/1"},{"type":"function","title":"Example: - ExOqs.Liboqs.generate_sign_keypair/1","doc":"iex> ExOqs.Liboqs.generate_sign_keypair(:Dilithium2)\n  {:ok,\n  {<<56, 189, 105, 230, 201, 243, 243, 0, 69, 157, 86, 113, 62, 90, 8, 73, 89,\n     94, 245, 73, 160, 87, 72, 130, 180, 14, 69, 37, 99, 248, 200, 38, 175, 246,\n     33, 55, 221, 121, 224, 181, 99, 229, 233, 130, 52, 155, 28, ...>>,\n   <<56, 189, 105, 230, 201, 243, 243, 0, 69, 157, 86, 113, 62, 90, 8, 73, 89,\n     94, 245, 73, 160, 87, 72, 130, 180, 14, 69, 37, 99, 248, 200, 38, 255, 240,\n     36, 110, 21, 86, 162, 4, 177, 3, 105, 51, 158, 206, ...>>}}","ref":"ExOqs.Liboqs.html#generate_sign_keypair/1-example"},{"type":"function","title":"ExOqs.Liboqs.load_lib/0","doc":"Load liboqs NIF shared library from environment","ref":"ExOqs.Liboqs.html#load_lib/0"},{"type":"function","title":"ExOqs.Liboqs.sign/3","doc":"Sign a given data and returns the signature","ref":"ExOqs.Liboqs.html#sign/3"},{"type":"function","title":"Example: - ExOqs.Liboqs.sign/3","doc":"iex> {:ok, {public, private}} = ExOqs.Liboqs.generate_sign_keypair(:Dilithium2)\n    {:ok,\n    {<<56, 189, 105, 230, 201, 243, 243, 0, 69, 157, 86, 113, 62, 90, 8, 73, 89,\n       94, 245, 73, 160, 87, 72, 130, 180, 14, 69, 37, 99, 248, 200, 38, 175, 246,\n       33, 55, 221, 121, 224, 181, 99, 229, 233, 130, 52, 155, 28, ...>>,\n     <<56, 189, 105, 230, 201, 243, 243, 0, 69, 157, 86, 113, 62, 90, 8, 73, 89,\n       94, 245, 73, 160, 87, 72, 130, 180, 14, 69, 37, 99, 248, 200, 38, 255, 240,\n       36, 110, 21, 86, 162, 4, 177, 3, 105, 51, 158, 206, ...>>}}\n\n    iex> {:ok, signature} = ExOqs.Liboqs.sign(:Dilithium2, private, \"Data requires integrity\") \n    {:ok,\n    <<116, 185, 55, 145, 246, 98, 208, 222, 0, 101, 105, 183, 173, 20, 251, 206,\n     78, 210, 158, 16, 211, 171, 211, 2, 120, 2, 91, 70, 215, 205, 65, 49, 34,\n     135, 200, 59, 108, 247, 149, 82, 90, 82, 253, 220, 175, 135, 13, 83, ...>>}","ref":"ExOqs.Liboqs.html#sign/3-example"},{"type":"function","title":"ExOqs.Liboqs.supported_kem_algo/0","doc":"Returns list of supported KEM algorithm from underlying liboqs library","ref":"ExOqs.Liboqs.html#supported_kem_algo/0"},{"type":"function","title":"Example: - ExOqs.Liboqs.supported_kem_algo/0","doc":"iex> ExOqs.Liboqs.supported_kem_algo()\n      [:\"BIKE-L1\", :\"BIKE-L3\", :\"BIKE-L5\", :\"Classic-McEliece-348864\",\n       :\"Classic-McEliece-348864f\", :\"Classic-McEliece-460896\",\n       :\"Classic-McEliece-460896f\", :\"Classic-McEliece-6688128\",\n       :\"Classic-McEliece-6688128f\", :\"Classic-McEliece-6960119\",\n       :\"Classic-McEliece-6960119f\", :\"Classic-McEliece-8192128\",\n       :\"Classic-McEliece-8192128f\", :\"HQC-128\", :\"HQC-192\", :\"HQC-256\", :Kyber512,\n       :Kyber768, :Kyber1024, :\"ML-KEM-512-ipd\", :\"ML-KEM-512\", :\"ML-KEM-768-ipd\",\n       :\"ML-KEM-768\", :\"ML-KEM-1024-ipd\", :\"ML-KEM-1024\", :sntrup761,\n       :\"FrodoKEM-640-AES\", :\"FrodoKEM-640-SHAKE\", :\"FrodoKEM-976-AES\",\n       :\"FrodoKEM-976-SHAKE\", :\"FrodoKEM-1344-AES\", :\"FrodoKEM-1344-SHAKE\"]","ref":"ExOqs.Liboqs.html#supported_kem_algo/0-example"},{"type":"function","title":"ExOqs.Liboqs.supported_sign_algo/0","doc":"Return list of enabled SIG algorithms from underlying liboqs library","ref":"ExOqs.Liboqs.html#supported_sign_algo/0"},{"type":"function","title":"Example: - ExOqs.Liboqs.supported_sign_algo/0","doc":"iex> ExOqs.Liboqs.supported_sign_algo()\n  [:Dilithium2, :Dilithium3, :Dilithium5, :\"ML-DSA-44-ipd\", :\"ML-DSA-44\",\n  :\"ML-DSA-65-ipd\", :\"ML-DSA-65\", :\"ML-DSA-87-ipd\", :\"ML-DSA-87\", :\"Falcon-512\",\n  :\"Falcon-1024\", :\"Falcon-padded-512\", :\"Falcon-padded-1024\",\n  :\"SPHINCS+-SHA2-128f-simple\", :\"SPHINCS+-SHA2-128s-simple\",\n  :\"SPHINCS+-SHA2-192f-simple\", :\"SPHINCS+-SHA2-192s-simple\",\n  :\"SPHINCS+-SHA2-256f-simple\", :\"SPHINCS+-SHA2-256s-simple\",\n  :\"SPHINCS+-SHAKE-128f-simple\", :\"SPHINCS+-SHAKE-128s-simple\",\n  :\"SPHINCS+-SHAKE-192f-simple\", :\"SPHINCS+-SHAKE-192s-simple\",\n  :\"SPHINCS+-SHAKE-256f-simple\", :\"SPHINCS+-SHAKE-256s-simple\", :\"KAZ-SIGN-1\",\n  :\"KAZ-SIGN-3\", :\"KAZ-SIGN-5\"]","ref":"ExOqs.Liboqs.html#supported_sign_algo/0-example"},{"type":"function","title":"ExOqs.Liboqs.verify/4","doc":"Verify a signature","ref":"ExOqs.Liboqs.html#verify/4"},{"type":"function","title":"Example: - ExOqs.Liboqs.verify/4","doc":"iex> res = ExOqs.Liboqs.verify(signature, :Dilithium2, public, \"Data requires integrity\") \n      {:ok, :verify_success}\n\n  iex> res = ExOqs.Liboqs.verify(signature, :Dilithium2, public, \"Data requires integrity but modified\") \n      {:ok, {:verify_error, -1}}","ref":"ExOqs.Liboqs.html#verify/4-example"},{"type":"module","title":"ExOqs.Liboqs.KEM","doc":"","ref":"ExOqs.Liboqs.KEM.html"},{"type":"function","title":"ExOqs.Liboqs.KEM.decaps/3","doc":"","ref":"ExOqs.Liboqs.KEM.html#decaps/3"},{"type":"function","title":"ExOqs.Liboqs.KEM.encaps/2","doc":"","ref":"ExOqs.Liboqs.KEM.html#encaps/2"},{"type":"function","title":"ExOqs.Liboqs.KEM.generate_keypair/1","doc":"","ref":"ExOqs.Liboqs.KEM.html#generate_keypair/1"},{"type":"function","title":"ExOqs.Liboqs.KEM.supported_algo/0","doc":"","ref":"ExOqs.Liboqs.KEM.html#supported_algo/0"},{"type":"module","title":"ExOqs.Liboqs.Sign","doc":"Module namespaced the liboqs SIG API","ref":"ExOqs.Liboqs.Sign.html"},{"type":"function","title":"ExOqs.Liboqs.Sign.generate_keypair/1","doc":"Generate keypair of given SIG algorithm","ref":"ExOqs.Liboqs.Sign.html#generate_keypair/1"},{"type":"function","title":"Example - ExOqs.Liboqs.Sign.generate_keypair/1","doc":"iex> ExOqs.Liboqs.Sign.generate_keypair(:Dilithium2)\n  {:ok, {<<2,3,4,..>>, <<20,41,24,211,..>>}}","ref":"ExOqs.Liboqs.Sign.html#generate_keypair/1-example"},{"type":"function","title":"ExOqs.Liboqs.Sign.sign/3","doc":"","ref":"ExOqs.Liboqs.Sign.html#sign/3"},{"type":"function","title":"ExOqs.Liboqs.Sign.supported_algo/0","doc":"","ref":"ExOqs.Liboqs.Sign.html#supported_algo/0"},{"type":"function","title":"ExOqs.Liboqs.Sign.verify/4","doc":"","ref":"ExOqs.Liboqs.Sign.html#verify/4"},{"type":"module","title":"ExOqs.OsUtils","doc":"","ref":"ExOqs.OsUtils.html"},{"type":"function","title":"ExOqs.OsUtils.detect_arch/1","doc":"","ref":"ExOqs.OsUtils.html#detect_arch/1"},{"type":"function","title":"ExOqs.OsUtils.detect_os/1","doc":"","ref":"ExOqs.OsUtils.html#detect_os/1"},{"type":"function","title":"ExOqs.OsUtils.os_info/0","doc":"","ref":"ExOqs.OsUtils.html#os_info/0"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,50,46,49]}}